  ##Y=X[4129:8451]/X[4128:8450]-1
  X=as.numeric(CAC40$Adj.Close)
  m=length(X)
  mm=3300
  Y=X[(mm+1):m]/X[mm:(m-1)]-1
  Y=na.omit(Y)
  acf(Y)
  Z=Y^2
  acf(Z)
  n=length(Z)
  AA=c()
  CC=c()
  K=225
  sig=mean((Z-mean(Z))^2)
  for (k in c(1:K))
  {
    B=sum((Z[c(1:(n-k))]-mean(Z))*(Z[c((1+k):(n))]-mean(Z)))/n
    AA=c(AA,B/sig)
    C=sum((Y[c(1:(n-k))]-mean(Y))*(Z[c((1+k):(n))]-mean(Z)))/n
    CC=c(CC,C)
  }
  ts.plot(AA)
  ts.plot(CC)
  
  library(car)
  x=c(1:K)
  lag=x
  dataAA=data.frame(x,AA)
  AA.nls=nls(AA ~ theta1+theta2*x^theta3,
            start=list(theta1=0, theta2 = 0.2, theta3 = -0.5),data=dataAA,trace=FALSE)
  summary(AA.nls); 
  xd <- data.frame(x=c(1:K))
  AA.fit <- predict(AA.nls,xd)
  CORX2=AA
    plot(lag,CORX2,'l')
    lines(x,AA.fit,col='red')
  
  dataCC=data.frame(x,CC)
  CC.nls=nls(CC ~ theta1*x^theta2,
            start=list(theta1=-0.0001, theta2 = -0.8),data=dataCC,trace=FALSE)
  summary(CC.nls); 
  xd <- data.frame(x=c(1:K))
  CC.fit <- predict(CC.nls,xd)
  CROSS12=CC
  plot(lag,CROSS12,'l')
  lines(x,CC.fit,col='red')
  
  library(expm)
  debut=1100
  fin=5100
  fen=4000
  r=1
  a0=c()
  cc=c()
  dd=c()
  ee=c()
  a0FZ=c()
  ccFZ=c()
  ddFZ=c()
  eeFZ=c()
  dep=1100
  Y1=Y[dep:(dep+fen)]
  n=length(Y1)
  C=quantile(abs(Y1),0.9,na.rm=TRUE)
  
############################# Model 1 ###################################  
  
  logLik=function(the)
  {z=0
  for (j in c(floor(n^0.5):n))
    z=z+(abs(Y1[j])-abs(the[1]+the[2]*(sum(c(1:(j-1))^(the[3]-1)*Y1[j-c(1:(j-1))]))))^2
  return(z)
  } 
  logLikFZ=function(the){
    z=0
    for (j in c(floor(n^0.5):n))
      z=z+(abs(Y1[j])^2-abs(the[1]+the[2]*(sum(c(1:(j-1))^(the[3]-1)*Y1[j-c(1:(j-1))])))^2)^2/
        (1+sum(abs(Y1[1:4])*(abs(Y1[1:4])>C))/C)^4
    return(z)
  }
  QMLE=optim(c(0.01,-0.2,0.4),logLik,method = "L-BFGS-B",lower = c(0.00001,-0.5,0), upper = c(1,0.5,0.5))
  QMLE$par
  QMLEFZ=optim(c(0.01,-0.2,0.4),logLikFZ,method = "L-BFGS-B",lower = c(0.00001,-0.5,0), upper = c(1,0.5,0.5))
  QMLEFZ$par
  
  z=0
  the=QMLE$par
  ll=n-floor(n^0.5)+1
  for (j in c(floor(n^0.5):n))
    z=z+Y1[j]^2/(the[1]+the[2]*sum(c(1:(j-1))^(the[3]-1)*Y1[j-c(1:(j-1))]))^2
  sigma2=z/ll
  
  QMLEFZ$par=QMLEFZ$par*c(1/sqrt(sigma2),1/sqrt(sigma2),1)
  
  Gamma1=matrix(0,3,3)
  DL=matrix(0,3,1)
  for (j in c(floor(n^0.5):n))
  {
    DL[1]=1
    DL[2]=sum(c(1:(j-1))^(the[3]-1)*Y1[j-c(1:(j-1))])
    DL[3]=the[2]*sum(log(c(1:(j-1)))*c(1:(j-1))^(the[3]-1)*Y1[j-c(1:(j-1))])
    Gamma1=Gamma1+DL%*%t(DL)
  }
  Gamma1=Gamma1/ll
  
  Gamma2=matrix(0,3,3)
  DL=matrix(0,3,1)
  for (j in c(floor(n^0.5):n))
  {
    DL[1]=1
    DL[2]=sum(c(1:(j-1))^(the[3]-1)*Y1[j-c(1:(j-1))])
    DL[3]=the[2]*sum(log(c(1:(j-1)))*c(1:(j-1))^(the[3]-1)*Y1[j-c(1:(j-1))])
    Gamma2=Gamma2+(the[1]+the[2]*sum(c(1:(j-1))^(the[3]-1)*Y1[j-c(1:(j-1))]))^2*DL%*%t(DL)
  }
  Gamma2=Gamma2/ll
  
  Asym=matrix(0,3,3)
  Gamma12 <- expm(-0.5*logm(Gamma1))
  Gamma22 <- expm(+0.5*logm(Gamma2))
  Asym=n^(-0.5)*(sigma2-1)^0.5*Gamma12%*%Gamma22%*%Gamma12
  
  c(the[1]-1.96*Asym[1,1],the[1]+1.96*Asym[1,1])
  c(the[2]-1.96*Asym[2,2],the[2]+1.96*Asym[2,2])
  c(the[3]-1.96*Asym[3,3],the[3]+1.96*Asym[3,3])
  
  Resi=0
  p=0
  for (j in c(floor(n^0.5):n))
  {p=p+1
  Resi[p]=Y1[j]/(the[1]+the[2]*sum(c(1:(j-1))^(the[3]-1)*Y1[j-c(1:(j-1))]))
  }
  acf(Resi)
  acf(abs(Resi))
  
############################# Model 2 ###################################  

logLik2=function(the)
  {z=0
  for (j in c(floor(n^0.5):n))
    z=z+(abs(Y1[j])-abs(the[1]+the[2]*sum((c(1:(j-1))^(the[3]-1)+the[4]*c(1:(j-1))^(the[3]-2))*Y1[j-c(1:(j-1))])))^2
  return(z)
  }
logLikFZ2=function(the){
    z=0
    for (j in c(floor(n^0.5):n))
      z=z+(abs(Y1[j])^2-abs(the[1]+the[2]*sum((c(1:(j-1))^(the[3]-1)+the[4]*c(1:(j-1))^(the[3]-2))*Y1[j-c(1:(j-1))]))^2)^2/
        (1+sum(abs(Y1[1:4])*(abs(Y1[1:4])>C))/C)^4
    return(z)
  }
  QMLE=optim(c(0.01,-0.2,0.4,0),logLik2,method = "L-BFGS-B",lower = c(0.00001,-0.5,0,-3), upper = c(1,0.5,0.5,3))
  the=round(QMLE$par,3) 
  the
  
  QMLEFZ=optim(the,logLikFZ2,method = "L-BFGS-B",lower = c(0.00001,-1,0,-3), upper = c(100,1,0.5,3))
  QMLEFZ$par

  Resi=0
  p=0
  for (j in c(floor(n^0.5):n))
  {p=p+1
  Resi[p]=Y1[j]/(the[1]+the[2]*sum((c(1:(j-1))^(the[3]-1)+the[4]*c(1:(j-1))^(the[3]-2))*Y1[j-c(1:(j-1))]))
  }
  ts.plot(Resi)
  sigma2=var(Resi*(abs(Resi)<30))
  acf(Resi)
  acf(abs(Resi))

  QMLEFZ$par=QMLEFZ$par*c(1/sqrt(sigma2),1/sqrt(sigma2),1,1)
  QMLEFZ$par
  
  mm=100000000
  sum(the[2]^2*(c(1:mm)^(the[3]-1)+the[4]*c(1:mm)^(the[3]-2))^2)  
  
Gamma1=matrix(0,4,4)
DL=matrix(0,4,1)
for (j in c(floor(n^0.5):n))
{
  DL[1]=1
  DL[2]=sum((c(1:(j-1))^(the[3]-1)+the[4]*c(1:(j-1))^(the[3]-2))*Y1[j-c(1:(j-1))])
  DL[3]=the[2]*sum(log(c(1:(j-1)))*(c(1:(j-1))^(the[3]-1)+the[4]*c(1:(j-1))^(the[3]-2))*Y1[j-c(1:(j-1))])
  DL[4]=the[2]*c(1:(j-1))^(the[3]-2)*Y1[j-c(1:(j-1))]
  Gamma1=Gamma1+DL%*%t(DL)
}
Gamma1=Gamma1/ll

Gamma2=matrix(0,4,4)
DL=matrix(0,4,1)
for (j in c(floor(n^0.5):n))
{
  DL[1]=1
  DL[2]=sum((c(1:(j-1))^(the[3]-1)+the[4]*c(1:(j-1))^(the[3]-2))*Y1[j-c(1:(j-1))])
  DL[3]=the[2]*sum(log(c(1:(j-1)))*(c(1:(j-1))^(the[3]-1)+the[4]*c(1:(j-1))^(the[3]-2))*Y1[j-c(1:(j-1))])
  DL[4]=the[2]*c(1:(j-1))^(the[3]-2)*Y1[j-c(1:(j-1))]
  Gamma2=Gamma2+(the[1]+the[2]*sum((c(1:(j-1))^(the[3]-1)+the[4]*c(1:(j-1))^(the[3]-2))*Y1[j-c(1:(j-1))]))^2*DL%*%t(DL)
}
Gamma2=Gamma2/ll

Asym=matrix(0,4,4)
Gamma12 <- expm(-0.5*logm(Gamma1))
Gamma22 <- expm(+0.5*logm(Gamma2))
Asym=n^(-0.5)*(sigma2-1)^0.5*Gamma12%*%Gamma22%*%Gamma12

c(the[1]-1.96*Asym[1,1],the[1]+1.96*Asym[1,1])
c(the[2]-1.96*Asym[2,2],the[2]+1.96*Asym[2,2])
c(the[3]-1.96*Asym[3,3],the[3]+1.96*Asym[3,3])
c(the[4]-1.96*Asym[4,4],the[4]+1.96*Asym[4,4])

  